<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>query/index.js - Documentation</title>

    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav>
    <li class="nav-link nav-home-link"><a href="index.html">Home</a></li><li class="nav-heading">Tutorials</li><li class="nav-item"><a href="tutorial-AccountMethods.html">Account Methods</a></li><li class="nav-item"><a href="tutorial-AddCustomProvider.html">Add Custom Provider</a></li><li class="nav-item"><a href="tutorial-AddWalletKeys.html">Add Wallet Keys</a></li><li class="nav-item"><a href="tutorial-AdminContracts.html">Admin contracts interfaces</a></li><li class="nav-item"><a href="tutorial-ChooseProviders.html">Choose Providers</a></li><li class="nav-item"><a href="tutorial-Conversions.html">Utils for conversions</a></li><li class="nav-item"><a href="tutorial-CreateWalletAccount.html">Create new wallet account</a></li><li class="nav-item"><a href="tutorial-EstimateGas.html">Estimate gas and costs</a></li><li class="nav-item"><a href="tutorial-HDwallet.html">Import keys from mnemonic</a></li><li class="nav-item"><a href="tutorial-OperationsContracts.html">Operations contracts interfaces</a></li><li class="nav-item"><a href="tutorial-Query.html">Query</a></li><li class="nav-item"><a href="tutorial-QuickStart.html">QuickStart</a></li><li class="nav-item"><a href="tutorial-USD.html">USD contract interface </a></li><li class="nav-item"><a href="tutorial-Withdrawals.html">Withdrawals</a></li><li class="nav-heading">Classes</li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="Accounts.html">Accounts</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.getAccounts">getAccounts</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.getBalance">getBalance</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.getBalances">getBalances</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.importFromSeed">importFromSeed</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.transfer">transfer</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="Accounts.html#.transferFrom">transferFrom</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="Contract.html">Contract</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="ContractsConfiguration.html">ContractsConfiguration</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.html">pm</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.contracts.html">contracts</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.provider.html">provider</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.providers.html">providers</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.utils.html">utils</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.fromToken">fromToken</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.isTransactionHash">isTransactionHash</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.sha256">sha256</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.html#.toToken">toToken</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="pm.wallet.html">wallet</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="Provider.html">Provider</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="ProviderConfiguration.html">ProviderConfiguration</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="ProviderConfigurationFiles.html">ProviderConfigurationFiles</a></span></li><li class="nav-heading"><span class="nav-item-type type-class">C</span><span class="nav-item-name"><a href="PublicMint.html">PublicMint</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="PublicMint.html#.provider">provider</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="PublicMint.html#.providers">providers</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="PublicMint.html#.versions">versions</a></span></li><li class="nav-heading">Modules</li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="module-Contracts.html">Contracts</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="module-Contracts.html#~InvalidAbiException">InvalidAbiException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="module-Contracts.html#~InvalidAddressException">InvalidAddressException</a></span></li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="module-Providers.html">Providers</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="module-Providers.html#~getProviderList">getProviderList</a></span></li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="pm.query.module_Query.html">Query</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~getWithdrawalTxByContract">getWithdrawalTxByContract</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~getWithdrawalTypeByContract">getWithdrawalTypeByContract</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~InvalidArgumentException">InvalidArgumentException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~InvalidContractException">InvalidContractException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.query.module_Query.html#~TransactionException">TransactionException</a></span></li><li class="nav-heading"><span class="nav-item-type type-module">M</span><span class="nav-item-name"><a href="pm.utils.module_Conversions.html">Conversions</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="pm.utils.module_Conversions.html#~Conversions">Conversions</a></span></li><li class="nav-heading"><a href="global.html">Globals</a></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_checkListener">_checkListener</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_createTxObject">_createTxObject</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_decodeEventABI">_decodeEventABI</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_decodeMethodReturn">_decodeMethodReturn</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_encodeEventABI">_encodeEventABI</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_encodeMethodABI">_encodeMethodABI</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_executeMethod">_executeMethod</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_generateEventOptions">_generateEventOptions</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_getCallback">_getCallback</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_getOrSetDefaultOptions">_getOrSetDefaultOptions</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_on">_on</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#_processExecuteArguments">_processExecuteArguments</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#clone">clone</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#deploy">deploy</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#getPastEvents">getPastEvents</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#InvalidProviderException">InvalidProviderException</a></span></li><li class="nav-item"><span class="nav-item-type type-function">F</span><span class="nav-item-name"><a href="global.html#once">once</a></span></li>
</nav>

<div id="main">
    
    <h1 class="page-title">query/index.js</h1>
    

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * Query module.
 * @module Query
 * @memberof pm.query
 */
import isObject from 'lodash/isObject';
import isString from 'lodash/isString';
import find from 'lodash/find';
import filter from 'lodash/filter';
import has from 'lodash/has';

/**
 * Find contract address in tokens contracts
 * @private
 * @param { pm.contracts.token } token- List of tokens  
 * @param { string } address - Contract address in string format to search 
 */
const _findAddressInTokens = (tokens, address) => {
    const _address = address.toLowerCase();
    return find(tokens, (token) => {
        return token.options.address.toLowerCase() === _address;
    })
};

/**
 * Find match in json interface by signature
 * @private
 * @param {*} interfaces 
 * @param {*} input 
 */
const _matchInterfaceSignature = (interfaces, input) => {
    const signature = input.slice(0, 10);
    return find(interfaces, ['signature', signature]);
}

/**
 * Filter all methods that start with 'withdraw' in contract instance
 * @private
 * @param {*} contract 
 */
const _getWithdrawalsInterface = (contract) => {
    return filter(contract.options.jsonInterface, (iface) => {
        return iface.hasOwnProperty('name') &amp;&amp; iface.name.startsWith("withdraw");
    })
}

/**
 * Given a contract instance and transactionHash resolves and decoded the input.
 * @private
 * @param {*} eth web3-eth with correct connection for blockchain
 * @param {*} contract web3-eth-contract instance
 * @param {*} transactionHash TransactionHash in string format
 * @throws { InvalidContractException | TransactionException } Throws when invalid parsing of transaction or contract abi
 */
const _resolveTransactionByInterface = async (eth, contract, transactionHash) => {
    let transaction;
    transaction = await eth.getTransaction(transactionHash);
    if (!transaction) {
        throw new TransactionException('Transaction not found');
    }
    const interfaces = _getWithdrawalsInterface(contract);

    if (interfaces.length === 0) {
        throw new InvalidContractException('Contract interface or withdrawals interface not exist');
    }
    if (!transaction.hasOwnProperty('input')) {
        throw new TransactionException('This transaction not have parameter input valid');
    }
    const matchedInterface = _matchInterfaceSignature(interfaces, transaction.input);

    if (matchedInterface === undefined) {
        throw new InvalidContractException('Transaction input is invalid, check if is transaction of this contract or withdrawal transaction.');
    }

    const type = matchedInterface.name;
    const decodedValue = eth.abi.decodeParameters(matchedInterface.inputs, '0x' + transaction.input.slice(10));

    return Promise.resolve({
        type,
        decodedValue,
        transaction,
        abi: matchedInterface
    });

}

/**
 * Validate parameters and resolve transaction
 * @private
 * @param {*} web3In web3 instance with provider
 * @param {*} contract web3-eth-contract instance or string address
 * @param {*} transactionHash - TransactionHash to be queried
 * @throws { InvalidArgumentException } - Invalid arguments
 */
const _getTransactionByContract = async (web3In, contract, transactionHash) => {
    // check if is valid transactionHash
    if (!web3In.pm.utils.isTransactionHash(transactionHash)) {
        throw new InvalidArgumentException("Invalid transaction hash");
    }
    // check if is an address
    if (isString(contract)) {
        if (!web3In.utils.isAddress(contract)) {
            throw new InvalidArgumentException("Invalid contract address");
        }
        // search in all contracts 
        const tokenInterface = _findAddressInTokens(web3In.pm.contracts.token, contract);
        return _resolveTransactionByInterface(web3In.eth, tokenInterface, transactionHash);
    }
    // check if is web3-contracts
    if (isObject(contract)) {
        if (!contract.hasOwnProperty('methods') &amp;&amp; !has(contract.methods, ['options', 'options.jsonInterface'])) {
            throw new InvalidArgumentException("Invalid contract instance, not have 'options' and jsonInterface");
        }
        return _resolveTransactionByInterface(web3In.eth, contract, transactionHash);
    }
};

/**
 * Invalid params exception
 * @param {string} message Error message
 */
function InvalidArgumentException(message) {
    this.message = message;
    this.name = 'InvalidArgumentException';
}

/**
 * Invalid contract exception
 * @param {string} message Error message
 */
function InvalidContractException(message) {
    this.message = message;
    this.name = 'InvalidContractException';
}

/**
 * Transaction exception
 * @param {string} message Error message
 */
function TransactionException(message) {
    this.message = message;
    this.name = 'TransactionException';
}

export default function (web3In) {
    return {
        /** 
         * getWithdrawalTransactionByContract
         * Resolve if transaction hash belongs to contract
         * @public
         * @param { string | web3.eth.contract } - Contract instance or address in string format
         * @param { string } - TransactionHash in hex string format 
         * @return { Object } - Result object
         * @throws { InvalidArgumentException | InvalidContractException }
         */
        getWithdrawalTxByContract: (contract, hash) => {
            return _getTransactionByContract(web3In, contract, hash);
        },
        /** 
         * getWithdrawalByTransactionInContract
         * Resolve if transaction hash belongs to contract
         * @public
         * @param { string | web3.eth.contract } - Contract instance or address in string format
         * @param { string } - TransactionHash in hex string format 
         * @return { string } - Result withdrawal type
         * @throws { InvalidArgumentException | InvalidContractException }
         */
        getWithdrawalTypeByContract: (contract, hash) => {
            return _getTransactionByContract(web3In, contract, hash).then(returnedValue => {
                return Promise.resolve(returnedValue.type)
            });
        }
    }
}
</code></pre>
        </article>
    </section>




</div>

<br class="clear">

<footer>
    Generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.3</a> on Fri Feb 21 2020 12:09:02 GMT+0000 (Western European Standard Time) using the Minami theme.
</footer>

<script>prettyPrint();</script>
<script src="scripts/linenumber.js"></script>
</body>
</html>
